package com.ints.bieshop.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class DiscountAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertDiscountAllPropertiesEquals(Discount expected, Discount actual) {
        assertDiscountAutoGeneratedPropertiesEquals(expected, actual);
        assertDiscountAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertDiscountAllUpdatablePropertiesEquals(Discount expected, Discount actual) {
        assertDiscountUpdatableFieldsEquals(expected, actual);
        assertDiscountUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertDiscountAutoGeneratedPropertiesEquals(Discount expected, Discount actual) {
        assertThat(expected)
            .as("Verify Discount auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertDiscountUpdatableFieldsEquals(Discount expected, Discount actual) {
        assertThat(expected)
            .as("Verify Discount relevant properties")
            .satisfies(e -> assertThat(e.getName()).as("check name").isEqualTo(actual.getName()))
            .satisfies(e -> assertThat(e.getDesc()).as("check desc").isEqualTo(actual.getDesc()))
            .satisfies(e -> assertThat(e.getDiscountRate()).as("check discountRate").isEqualTo(actual.getDiscountRate()))
            .satisfies(e -> assertThat(e.getStartDate()).as("check startDate").isEqualTo(actual.getStartDate()))
            .satisfies(e -> assertThat(e.getEndDate()).as("check endDate").isEqualTo(actual.getEndDate()))
            .satisfies(e -> assertThat(e.getIsDeleted()).as("check isDeleted").isEqualTo(actual.getIsDeleted()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertDiscountUpdatableRelationshipsEquals(Discount expected, Discount actual) {}
}
